searchData={"items":[{"type":"module","title":"ExICE.Candidate","doc":"ICE candidate representation.","ref":"ExICE.Candidate.html"},{"type":"function","title":"ExICE.Candidate.family/1","doc":"","ref":"ExICE.Candidate.html#family/1"},{"type":"function","title":"ExICE.Candidate.marshal/1","doc":"","ref":"ExICE.Candidate.html#marshal/1"},{"type":"function","title":"ExICE.Candidate.unmarshal/1","doc":"","ref":"ExICE.Candidate.html#unmarshal/1"},{"type":"type","title":"ExICE.Candidate.t/0","doc":"","ref":"ExICE.Candidate.html#t:t/0"},{"type":"type","title":"ExICE.Candidate.type/0","doc":"","ref":"ExICE.Candidate.html#t:type/0"},{"type":"module","title":"ExICE.CandidatePair","doc":"ICE candidate pair representation.","ref":"ExICE.CandidatePair.html"},{"type":"type","title":"ExICE.CandidatePair.state/0","doc":"","ref":"ExICE.CandidatePair.html#t:state/0"},{"type":"type","title":"ExICE.CandidatePair.t/0","doc":"","ref":"ExICE.CandidatePair.html#t:t/0"},{"type":"module","title":"ExICE.ICEAgent","doc":"ICE Agent.\n\nNot to be confused with Elixir Agent.","ref":"ExICE.ICEAgent.html"},{"type":"function","title":"ExICE.ICEAgent.add_remote_candidate/2","doc":"Adds a remote candidate.\n\nIf an ICE agent has already gathered any local candidates and\nhave remote credentials set, adding a remote candidate will start\nconnectivity checks.","ref":"ExICE.ICEAgent.html#add_remote_candidate/2"},{"type":"function","title":"ExICE.ICEAgent.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"ExICE.ICEAgent.html#child_spec/1"},{"type":"function","title":"ExICE.ICEAgent.end_of_candidates/1","doc":"Informs ICE agent that a remote side finished its gathering process.\n\nCall to this function is mandatory to nominate a pair (when an agent is the `controlling` one)\nand in turn move to the `completed` state.","ref":"ExICE.ICEAgent.html#end_of_candidates/1"},{"type":"function","title":"ExICE.ICEAgent.gather_candidates/1","doc":"Starts ICE gathering process.\n\nOnce a new candidate is discovered, it is sent as a message to the controlling process.\nSee `t:signal/0` for a message structure.","ref":"ExICE.ICEAgent.html#gather_candidates/1"},{"type":"function","title":"ExICE.ICEAgent.get_local_candidates/1","doc":"Gets all local candidates that have already been gathered.","ref":"ExICE.ICEAgent.html#get_local_candidates/1"},{"type":"function","title":"ExICE.ICEAgent.get_local_credentials/1","doc":"Gets local credentials.\n\nThey remain unchanged until ICE restart.","ref":"ExICE.ICEAgent.html#get_local_credentials/1"},{"type":"function","title":"ExICE.ICEAgent.get_remote_candidates/1","doc":"Gets all remote candidates.\n\nThis includes candidates supplied by `add_remote_candidate/2` and candidates\ndiscovered during ICE connection establishment process (so called `prflx` candidates).","ref":"ExICE.ICEAgent.html#get_remote_candidates/1"},{"type":"function","title":"ExICE.ICEAgent.get_stats/1","doc":"Gathers ICE agent statistics.\n\n* `bytes_sent` - data bytes sent. This does not include connectivity checks and UDP/IP header sizes.\n* `bytes_received` - data bytes received. This does not include connectivity checks and UDP/IP header sizes.\n* `packets_sent` - data packets sent. This does not include connectivity checks.\n* `packets_received` - data packets received. This does not include connectivity checks.\n* `candidate_pairs` - list of current candidate pairs. Changes after doing an ICE restart.","ref":"ExICE.ICEAgent.html#get_stats/1"},{"type":"function","title":"ExICE.ICEAgent.on_connection_state_change/2","doc":"Configures where to send connection state change notifications.","ref":"ExICE.ICEAgent.html#on_connection_state_change/2"},{"type":"function","title":"ExICE.ICEAgent.on_data/2","doc":"Configures where to send data.","ref":"ExICE.ICEAgent.html#on_data/2"},{"type":"function","title":"ExICE.ICEAgent.on_gathering_state_change/2","doc":"Configures where to send gathering state change notifications.","ref":"ExICE.ICEAgent.html#on_gathering_state_change/2"},{"type":"function","title":"ExICE.ICEAgent.on_new_candidate/2","doc":"Configures where to send new candidates.","ref":"ExICE.ICEAgent.html#on_new_candidate/2"},{"type":"function","title":"ExICE.ICEAgent.restart/1","doc":"Restarts ICE.\n\nIf there were any valid pairs in the previous ICE session,\ndata can still be sent.","ref":"ExICE.ICEAgent.html#restart/1"},{"type":"function","title":"ExICE.ICEAgent.send_data/2","doc":"Sends data.\n\nCan only be called after moving to the `connected` state.","ref":"ExICE.ICEAgent.html#send_data/2"},{"type":"function","title":"ExICE.ICEAgent.set_remote_credentials/3","doc":"Sets remote credentials.\n\nCall to this function is mandatory to start connectivity checks.","ref":"ExICE.ICEAgent.html#set_remote_credentials/3"},{"type":"function","title":"ExICE.ICEAgent.start_link/2","doc":"Starts and links a new ICE agent.\n\nProcess calling this function is called a `controlling process` and\nhas to be prepared for receiving ExICE messages described by `t:signal/0`.","ref":"ExICE.ICEAgent.html#start_link/2"},{"type":"function","title":"ExICE.ICEAgent.stop/1","doc":"Stops ICE agent and all of its sockets.","ref":"ExICE.ICEAgent.html#stop/1"},{"type":"type","title":"ExICE.ICEAgent.connection_state_change/0","doc":"Emitted when connection state has changed.\n\nFor exact meaning refer to the W3C WebRTC standard, sec. 5.6.4.","ref":"ExICE.ICEAgent.html#t:connection_state_change/0"},{"type":"type","title":"ExICE.ICEAgent.gathering_state_change/0","doc":"Emitted when gathering process state has changed.\n\nFor exact meaning refer to the W3C WebRTC standard, sec 5.6.3.","ref":"ExICE.ICEAgent.html#t:gathering_state_change/0"},{"type":"type","title":"ExICE.ICEAgent.ip_filter/0","doc":"Filter applied when gathering host candidates.","ref":"ExICE.ICEAgent.html#t:ip_filter/0"},{"type":"type","title":"ExICE.ICEAgent.opts/0","doc":"ICE Agent configuration options.\nAll notifications are by default sent to a process that spawns `ExICE`.\nThis behavior can be overwritten using the following options.\n\n* `ip_filter` - filter applied when gathering host candidates\n* `ports` - ports that will be used when gathering host candidates, otherwise the ports are chosen by the OS\n* `ice_servers` - list of STUN/TURN servers\n* `ice_transport_policy` - candidate types to be used.\n  * `all` - all ICE candidates will be considered (default).\n  * `relay` - only relay candidates will be considered.\n* `on_gathering_state_change` - where to send gathering state change notifications. Defaults to a process that spawns `ExICE`.\n* `on_connection_state_change` - where to send connection state change notifications. Defaults to a process that spawns `ExICE`.\n* `on_data` - where to send data. Defaults to a process that spawns `ExICE`.\n* `on_new_candidate` - where to send new candidates. Defaults to a process that spawns `ExICE`.","ref":"ExICE.ICEAgent.html#t:opts/0"},{"type":"type","title":"ExICE.ICEAgent.role/0","doc":"ICE agent role.\n\n`:controlling` agent is responsible for nominating a pair.","ref":"ExICE.ICEAgent.html#t:role/0"},{"type":"type","title":"ExICE.ICEAgent.signal/0","doc":"Messages sent by the ExICE.","ref":"ExICE.ICEAgent.html#t:signal/0"},{"type":"extras","title":"ExICE","doc":"# ExICE\n\n[![Hex.pm](https://img.shields.io/hexpm/v/ex_ice.svg)](https://hex.pm/packages/ex_ice)\n[![API Docs](https://img.shields.io/badge/api-docs-yellow.svg?style=flat)](https://hexdocs.pm/ex_ice)\n[![CI](https://img.shields.io/github/actions/workflow/status/elixir-webrtc/ex_ice/ci.yml?logo=github&label=CI)](https://github.com/elixir-webrtc/ex_ice/actions/workflows/ci.yml)\n[![codecov](https://codecov.io/gh/elixir-webrtc/ex_ice/graph/badge.svg?token=E98NHC8B00)](https://codecov.io/gh/elixir-webrtc/ex_ice)\n\nTrickle ICE implementation.\n\nImplements:\n* [RFC 8445](https://datatracker.ietf.org/doc/html/rfc8445)\n* [RFC 8838](https://datatracker.ietf.org/doc/html/rfc8838)\n* [ICE mDNS](https://datatracker.ietf.org/doc/html/draft-ietf-rtcweb-mdns-ice-candidates) (client side)","ref":"readme.html"},{"type":"extras","title":"Features - ExICE","doc":"* compatible both with aggressive and regular nomination\n* role conflict resolution\n* supports host, prflx, srflx and relay candidates\n* transaction pacing\n* keepalives (both incoming and outgoing) on valid and selected pairs\n* mDNS client","ref":"readme.html#features"},{"type":"extras","title":"Limitations - ExICE","doc":"* there is always only one stream and one component -\nwe don't plan to add support for multiple streams and components\nas WebRTC multiplexes traffic on a single socket but PRs are welcomed","ref":"readme.html#limitations"},{"type":"extras","title":"Installation - ExICE","doc":"```elixir\ndef deps do\n  [\n    {:ex_ice, \"~> 0.8.4\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - ExICE","doc":"See our [example](https://github.com/elixir-webrtc/ex_ice/tree/master/example), \n[integration tests](https://github.com/elixir-webrtc/ex_ice/blob/master/test/integration/p2p_test.exs),\nand [documentation](https://hexdocs.pm/ex_ice/readme.html) for usage examples.\n\nWe also provide a very simple [signalling server](https://github.com/elixir-webrtc/ex_ice/tree/master/signalling_server), which can be used\nto connect two ICE agents.","ref":"readme.html#usage"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.35.1"}}